<template>
  <v-app>
    <v-navigation-drawer
      clipped
      fixed
      app
      v-model="showMenu"
    >
      <v-list>
        <v-list-tile
          router
          :to="item.to"
          :key="i"
          v-for="(item, i) in menuItems"
          exact
        >
          <v-list-tile-action>
            <v-icon v-html="item.icon"></v-icon>
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title class="menu-text" v-text="item.title"></v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
      </v-list>
    </v-navigation-drawer>
    <v-toolbar fixed app :clipped-left="true">
      <v-btn
        icon
        @click="showMenu=!showMenu"
      >
        <v-icon>menu</v-icon>
      </v-btn>
      <v-toolbar-title class="main-title" v-text="title"></v-toolbar-title>
      <v-spacer></v-spacer>
      <v-btn
        icon
        @click="showNewPlantDialog=true"
      >
        <v-icon color="green darken-2">fa-leaf</v-icon>
      </v-btn>
      <v-btn
        icon
        @click="showNewTodoDialog=true"
      >
        <v-icon color="grey lighten-1">check_box</v-icon>
      </v-btn>
      <v-btn
        icon
        @click="showNewNoteDialog=true"
      >
        <v-icon color="grey darken-2">create</v-icon>
      </v-btn>
    </v-toolbar>
    <v-content>
      <v-container>
        <nuxt />
      </v-container>
    </v-content>
    <v-dialog v-model="showNewPlantDialog" max-width="650px">
      <v-stepper v-model="plantStepper" vertical>
        <v-stepper-step :complete=" plantStepper > 1" step="1">
          Plant Info
          <small>Name and extra information</small>
        </v-stepper-step>
        <v-stepper-content step="1">
          <v-flex class="mb-5" height="200px">
            <v-form>
                <v-text-field
                  v-model="newPlant.name"
                  label="Plant Name/Type"
                  required
                ></v-text-field>
                <v-text-field
                  v-model="newPlant.info"
                  label="Info"
                ></v-text-field>
              </v-form>
          </v-flex>
          <v-layout row wrap>
            <v-btn color="secondary" @click="showNewPlantDialog=false">Cancel</v-btn>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click.native="plantStepper = 2">Continue</v-btn>
          </v-layout>
        </v-stepper-content>
        <v-stepper-step :complete="plantStepper > 2" step="2">Date Planted</v-stepper-step>
        <v-stepper-content step="2">
          <v-flex class="mb-5" height="200px">
            <v-date-picker v-model="newPlant.date" reactive full-width></v-date-picker>
          </v-flex>
          <v-layout row wrap>
            <v-btn color="secondary" @click="showNewPlantDialog=false">Cancel</v-btn>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click.native="plantStepper = 1">Back</v-btn>
            <v-btn color="primary" @click.native="plantStepper = 3">Continue</v-btn>
          </v-layout>
        </v-stepper-content>
        <v-stepper-step :complete="plantStepper > 3" step="3">Harvest Period</v-stepper-step>
        <v-stepper-content step="3">
          <v-flex class="mb-5" height="200px">
            <v-menu
              :close-on-content-click="false"
              v-model="plantHarvestField1"
              :nudge-right="40"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              max-width="290px"
              min-width="290px"
            >
              <v-text-field
                slot="activator"
                label="Harvest start date"
                prepend-icon="event"
                v-model="newPlant.harvestStartDate"
                readonly
              ></v-text-field>
              <v-date-picker v-model="newPlant.harvestStartDate" no-title @input="plantHarvestField1 = false"></v-date-picker>
            </v-menu>
            <v-menu
              :close-on-content-click="false"
              v-model="plantHarvestField2"
              :nudge-right="40"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              max-width="290px"
              min-width="290px"
            >
              <v-text-field
                slot="activator"
                label="Harvest end date"
                prepend-icon="event"
                v-model="newPlant.harvestEndDate"
                readonly
              ></v-text-field>
              <v-date-picker v-model="newPlant.harvestEndDate" no-title @input="plantHarvestField2 = false"></v-date-picker>
            </v-menu>
          </v-flex>
          <v-layout row wrap>
            <v-btn color="secondary" @click="showNewPlantDialog=false">Cancel</v-btn>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click.native="plantStepper = 2">Back</v-btn>
            <v-btn color="green" @click="showNewPlantDialog=false, savePlant()">Plant</v-btn>
          </v-layout>
        </v-stepper-content>
      </v-stepper>
    </v-dialog>
    <v-dialog v-model="showNewTodoDialog" max-width="650px">
      <v-card>
        <v-card-title>
          New To Do
        </v-card-title>
        <v-card-text>
          <v-layout row row-wrap>
            <v-flex>
              <v-date-picker v-model="newTodo.month" type="month" reactive></v-date-picker>
            </v-flex>
            <v-flex>
              <v-form>
                <v-text-field
                  v-model="newTodo.text"
                  label="What do you need to do?"
                  required
                ></v-text-field>
              </v-form>
            </v-flex>
          </v-layout>
        </v-card-text>
        <v-card-actions>
          <v-btn color="secondary" @click="showNewTodoDialog=false">Cancel</v-btn>
          <v-spacer></v-spacer>
          <v-btn color="green" @click="showNewTodoDialog=false, saveTodo()">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="showNewNoteDialog" max-width="650px">
      <v-card>
        <v-card-title>
          New Note
        </v-card-title>
        <v-card-text>
          <v-layout row row-wrap>
            <v-flex>
              <v-date-picker v-model="newNote.month" type="month" reactive></v-date-picker>
            </v-flex>
            <v-flex>
              <v-form>
                <v-text-field
                  v-model="newNote.title"
                  label="Note title"
                  required
                ></v-text-field>
                <v-text-field
                  v-model="newNote.text"
                  label="Note text"
                  required
                ></v-text-field>
              </v-form>
            </v-flex>
          </v-layout>
        </v-card-text>
        <v-card-actions>
          <v-btn color="secondary" @click="showNewNoteDialog=false">Cancel</v-btn>
          <v-spacer></v-spacer>
          <v-btn color="green" @click="showNewNoteDialog=false, saveNote()">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-footer fixed app>
      <v-btn
        color="secondary"
        @click="signout"
      >Sign Out</v-btn>
    </v-footer>
  </v-app>
</template>

<script>
import plant from '~/assets/js/plant.js'
import todo from '~/assets/js/todo.js'
import note from '~/assets/js/note.js'
import firebase from 'firebase'

export default {
  props: ['month'],
  data () {
    return {
      title: 'Allotment Planner',
      showMenu: true,
      menuItems: [
        { icon: 'ac_unit', title: 'January', to: '/january' },
        { icon: 'ac_unit', title: 'February', to: '/february' },
        { icon: 'wb_cloudy', title: 'March', to: '/march' },
        { icon: 'wb_cloudy', title: 'April', to: '/april' },
        { icon: 'wb_cloudy', title: 'May', to: '/may' },
        { icon: 'wb_sunny', title: 'June', to: '/june' },
        { icon: 'wb_sunny', title: 'July', to: '/july' },
        { icon: 'wb_sunny', title: 'August', to: '/august' },
        { icon: 'wb_cloudy', title: 'September', to: '/september' },
        { icon: 'wb_cloudy', title: 'October', to: '/october' },
        { icon: 'wb_cloudy', title: 'November', to: '/november' },
        { icon: 'ac_unit', title: 'December', to: '/december' }
      ],
      showNewPlantDialog: false,
      showNewTodoDialog: false,
      showNewNoteDialog: false,
      plantStepper: 0,
      plantHarvestField1: false,
      plantHarvestField2: false,
      newPlant: {
        date: '',
        name: '',
        info: '',
        harvestStartDate: '',
        harvestEndDate: ''
      },
      newTodo: {
        month: '',
        text: '',
        done: false,
        timestamp: ''
      },
      newNote: {
        month: '',
        title: '',
        text: ''
      }
    }
  },
  methods: {
    savePlant () {
      try {
        let parsedPlant = plant.parse(this.newPlant)
        plant.save(this, parsedPlant)
        this.plantStepper = 1
        this.newPlant = {
          date: '',
          name: '',
          info: '',
          harvestStartDate: '',
          harvestEndDate: ''
        }
      } catch (e) {
        console.log(e)
      }
    },
    saveTodo () {
      try {
        let parsedTodo = todo.parse(this.newTodo)
        todo.save(this, parsedTodo)
      } catch (e) {
        console.log(e)
      }
    },
    saveNote () {
      try {
        let parsedNote = note.parse(this.newNote)
        note.save(this, parsedNote)
      } catch (e) {
        console.log(e)
      }
    },
    signout () {
      firebase
        .auth()
        .signOut()
        .then(() => {
          // window.location.replace('login')
        })
    }
  }
}
</script>
